action.yml 7.9 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202
  1. # NOTE: Do not rely on `make` commands here as this action is used across different repos
  2. # where the Makefile will not be available
  3. name: 'Sentry Setup'
  4. description: 'Sets up a Sentry test environment'
  5. inputs:
  6. workdir:
  7. description: 'Directory where the sentry source is located'
  8. required: false
  9. default: '.'
  10. snuba:
  11. description: 'Is snuba required?'
  12. required: false
  13. default: 'false'
  14. clickhouse:
  15. description: 'Is clickhouse required?'
  16. required: false
  17. default: 'false'
  18. kafka:
  19. description: 'Is kafka required?'
  20. required: false
  21. default: 'false'
  22. chartcuterie:
  23. description: 'Is chartcuterie required?'
  24. required: false
  25. default: 'false'
  26. bigtable:
  27. description: 'Is bigtable required?'
  28. required: false
  29. default: 'false'
  30. python-version:
  31. description: 'python version to install'
  32. required: false
  33. default: '3.8.16'
  34. pg-version:
  35. description: 'PostgreSQL version to use'
  36. default: '14'
  37. required: false
  38. outputs:
  39. yarn-cache-dir:
  40. description: 'Path to yarn cache'
  41. value: ${{ steps.config.outputs.yarn-cache-dir }}
  42. matrix-instance-number:
  43. description: 'The matrix instance number (starting at 1)'
  44. value: ${{ steps.config.outputs.matrix-instance-number }}
  45. matrix-instance-total:
  46. description: 'Reexport of MATRIX_INSTANCE_TOTAL.'
  47. value: ${{ steps.config.outputs.matrix-instance-total }}
  48. runs:
  49. using: 'composite'
  50. steps:
  51. - name: Setup default environment variables
  52. # the default for "bash" is:
  53. # bash --noprofile --norc -eo pipefail {0}
  54. shell: bash --noprofile --norc -eo pipefail -ux {0}
  55. env:
  56. MATRIX_INSTANCE: ${{ matrix.instance }}
  57. # XXX: We should be using something like len(strategy.matrix.instance) (not possible atm)
  58. # If you have other things like python-version: [foo, bar, baz] then the sharding logic
  59. # isn't right because job-total will be 3x larger and you'd never run 2/3 of the tests.
  60. # MATRIX_INSTANCE_TOTAL: ${{ strategy.job-total }}
  61. run: |
  62. echo "PIP_DISABLE_PIP_VERSION_CHECK=on" >> $GITHUB_ENV
  63. echo "PIP_INDEX_URL=https://pypi.devinfra.sentry.io/simple" >> $GITHUB_ENV
  64. echo "SENTRY_SKIP_BACKEND_VALIDATION=1" >> $GITHUB_ENV
  65. ### node configuration ###
  66. echo "NODE_ENV=development" >> $GITHUB_ENV
  67. echo "NODE_OPTIONS=--max-old-space-size=4096" >> $GITHUB_ENV
  68. ### pytest configuration ###
  69. echo "PY_COLORS=1" >> "$GITHUB_ENV"
  70. echo "PYTEST_ADDOPTS=--reruns=5 --durations=10 --fail-slow=60s" >> $GITHUB_ENV
  71. ### pytest-sentry configuration ###
  72. if [ "$GITHUB_REPOSITORY" = "getsentry/sentry" ]; then
  73. echo "PYTEST_SENTRY_DSN=https://6fd5cfea2d4d46b182ad214ac7810508@sentry.io/2423079" >> $GITHUB_ENV
  74. echo "PYTEST_SENTRY_TRACES_SAMPLE_RATE=0" >> $GITHUB_ENV
  75. # This records failures on master to sentry in order to detect flakey tests, as it's
  76. # expected that people have failing tests on their PRs
  77. if [ "$GITHUB_REF" = "refs/heads/master" ]; then
  78. echo "PYTEST_SENTRY_ALWAYS_REPORT=1" >> $GITHUB_ENV
  79. fi
  80. fi
  81. # Configure a different release version, otherwise it defaults to the
  82. # commit sha which will conflict with our actual prod releases. This is a
  83. # confusing experience because it looks like these are "empty" releases
  84. # because no commits are attached and associates the release with our
  85. # javascript + sentry projects.
  86. echo "SENTRY_RELEASE=ci@$GITHUB_SHA" >> $GITHUB_ENV
  87. # this handles pytest test sharding
  88. if [ "$MATRIX_INSTANCE" ]; then
  89. if ! [ "${MATRIX_INSTANCE_TOTAL:-}" ]; then
  90. echo "MATRIX_INSTANCE_TOTAL is required."
  91. exit 1
  92. fi
  93. echo "TEST_GROUP=$MATRIX_INSTANCE" >> $GITHUB_ENV
  94. echo "TOTAL_TEST_GROUPS=$MATRIX_INSTANCE_TOTAL" >> $GITHUB_ENV
  95. fi
  96. - uses: getsentry/action-setup-venv@9e3bbae3836b1b6f129955bf55a19e1d99a61c67 # v1.0.5
  97. with:
  98. python-version: ${{ inputs.python-version }}
  99. cache-dependency-path: ${{ inputs.workdir }}/requirements-dev-frozen.txt
  100. install-cmd: pip install -r ${{ inputs.workdir }}/requirements-dev-frozen.txt
  101. - name: Set up outputs
  102. id: config
  103. env:
  104. MATRIX_INSTANCE: ${{ matrix.instance }}
  105. shell: bash --noprofile --norc -eo pipefail -ux {0}
  106. run: |
  107. echo "yarn-cache-dir=$(yarn cache dir)" >> "$GITHUB_OUTPUT"
  108. echo "matrix-instance-number=$(($MATRIX_INSTANCE+1))" >> "$GITHUB_OUTPUT"
  109. echo "matrix-instance-total=$((${MATRIX_INSTANCE_TOTAL:-}))" >> "$GITHUB_OUTPUT"
  110. - name: Install python dependencies
  111. shell: bash --noprofile --norc -eo pipefail -ux {0}
  112. env:
  113. # This is necessary when other repositories (e.g. relay) want to take advantage of this workflow
  114. # without needing to fork it. The path needed is the one where setup.py is located
  115. WORKDIR: ${{ inputs.workdir }}
  116. run: |
  117. cd "$WORKDIR"
  118. # We need to install editable otherwise things like check migration will fail.
  119. SENTRY_LIGHT_BUILD=1 pip install --no-deps -e .
  120. - name: Start devservices
  121. shell: bash --noprofile --norc -eo pipefail -ux {0}
  122. env:
  123. NEED_KAFKA: ${{ inputs.kafka }}
  124. NEED_SNUBA: ${{ inputs.snuba }}
  125. NEED_CLICKHOUSE: ${{ inputs.clickhouse }}
  126. NEED_BIGTABLE: ${{ inputs.bigtable }}
  127. NEED_CHARTCUTERIE: ${{ inputs.chartcuterie }}
  128. WORKDIR: ${{ inputs.workdir }}
  129. PG_VERSION: ${{ inputs.pg-version }}
  130. ENABLE_AUTORUN_MIGRATION_SEARCH_ISSUES: '1'
  131. run: |
  132. sentry init
  133. # redis, postgres are needed for almost every code path.
  134. services='redis postgres'
  135. if [ "$NEED_CLICKHOUSE" = "true" ] || [ "$NEED_SNUBA" = "true" ]; then
  136. services="${services} clickhouse"
  137. fi
  138. if [ "$NEED_SNUBA" = "true" ]; then
  139. services="${services} snuba"
  140. fi
  141. if [ "$NEED_BIGTABLE" = "true" ]; then
  142. echo "BIGTABLE_EMULATOR_HOST=127.0.0.1:8086" >> $GITHUB_ENV
  143. services="${services} bigtable"
  144. fi
  145. if [ "$NEED_CHARTCUTERIE" = "true" ]; then
  146. services="${services} chartcuterie"
  147. fi
  148. sentry devservices up $services &
  149. # TODO: Use devservices kafka. See https://github.com/getsentry/sentry/pull/20986#issuecomment-704510570
  150. if [ "$NEED_KAFKA" = "true" ]; then
  151. # This is *not* the production version. Unclear reason as to why this was chosen
  152. # https://github.com/getsentry/ops/blob/c823e62f930ecc6c97bb08898c71e49edc7232f6/cookbooks/getsentry/attributes/default.rb#L631
  153. docker run \
  154. --name sentry_zookeeper \
  155. -d --network host \
  156. -e ZOOKEEPER_CLIENT_PORT=2181 \
  157. confluentinc/cp-zookeeper:4.1.0 \
  158. &
  159. # This is the production version; do not change w/o changing it there as well
  160. # https://github.com/getsentry/ops/blob/c823e62f930ecc6c97bb08898c71e49edc7232f6/cookbooks/getsentry/attributes/default.rb#L643
  161. docker run \
  162. --name sentry_kafka \
  163. -d --network host \
  164. -e KAFKA_ZOOKEEPER_CONNECT=127.0.0.1:2181 \
  165. -e KAFKA_LISTENERS=INTERNAL://0.0.0.0:9093,EXTERNAL://0.0.0.0:9092 \
  166. -e KAFKA_ADVERTISED_LISTENERS=INTERNAL://127.0.0.1:9093,EXTERNAL://127.0.0.1:9092 \
  167. -e KAFKA_LISTENER_SECURITY_PROTOCOL_MAP=INTERNAL:PLAINTEXT,EXTERNAL:PLAINTEXT \
  168. -e KAFKA_INTER_BROKER_LISTENER_NAME=INTERNAL \
  169. -e KAFKA_OFFSETS_TOPIC_REPLICATION_FACTOR=1 \
  170. confluentinc/cp-kafka:5.1.2 \
  171. &
  172. fi
  173. wait
  174. docker ps -a
  175. # This is necessary when other repositories (e.g. relay) want to take advantage of this workflow
  176. # without needing to fork it. The path needed is the one where tools are located
  177. cd "$WORKDIR"
  178. python3 -u -S -m tools.devservices_healthcheck
  179. cd -